    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * -------------------
    028 * XmlReadHandler.java
    029 * -------------------
    030 * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: XmlReadHandler.java,v 1.3 2005/10/18 13:32:52 mungady Exp $
    036 *
    037 * Changes (from 25-Nov-2003)
    038 * --------------------------
    039 * 25-Nov-2003 : Added Javadocs (DG);
    040 *
    041 */
    042
    043package org.jfree.xml.parser;
    044
    045import org.xml.sax.Attributes;
    046import org.xml.sax.SAXException;
    047
    048/**
    049 * A handler for reading an XML element.
    050 */
    051public interface XmlReadHandler {
    052
    053    /**
    054     * This method is called at the start of an element.
    055     *
    056     * @param tagName  the tag name.
    057     * @param attrs  the attributes.
    058     *
    059     * @throws SAXException if there is a parsing error.
    060     * @throws XmlReaderException if there is a reader error.
    061     */
    062    public void startElement(String tagName, Attributes attrs)
    063        throws SAXException, XmlReaderException;
    064
    065    /**
    066     * This method is called to process the character data between element tags.
    067     *
    068     * @param ch  the character buffer.
    069     * @param start  the start index.
    070     * @param length  the length.
    071     *
    072     * @throws SAXException if there is a parsing error.
    073     */
    074    public void characters(char[] ch, int start, int length)
    075        throws SAXException;
    076
    077    /**
    078     * This method is called at the end of an element.
    079     *
    080     * @param tagName  the tag name.
    081     *
    082     * @throws SAXException if there is a parsing error.
    083     * @throws XmlReaderException if there is a reader error.
    084     */
    085    public void endElement(String tagName)
    086        throws SAXException, XmlReaderException;
    087
    088    /**
    089     * Returns the object for this element or null, if this element does
    090     * not create an object.
    091     *
    092     * @return the object.
    093     *
    094     * @throws XmlReaderException if there is a parsing error.
    095     */
    096    public Object getObject() throws XmlReaderException;
    097
    098    /**
    099     * Initialise.
    100     *
    101     * @param rootHandler  the root handler.
    102     * @param tagName  the tag name.
    103     */
    104    public void init(RootXmlReadHandler rootHandler, String tagName);
    105
    106}